`timescale 1ns/10ps
module tb(); 

  // <Parameter declarations here>

  // <All signal declarations here>

  localparam noDutSignalBits = <total number of signal bits>; 
  localparam noClocks = <number of clock cycles involved in assertion>; 
  localparam log2NoClocks = <log2(noClocks) ceiled to integer>
  localparam CTR_WIDTH = (noDutSignalBits*noClocks) + log2NoClocks; 
    // + log2NoClocks to keep track of how to update test data

  // generate clock and reset
  initial begin 
    clk = 'b0; 
    rst = 'b1; 
    #18 rst = 'b0; 
  end
  always #5 clk <= ~clk; 
  
  // generate tests
  reg [CTR_WIDTH-1:0] test_data; 
  wire [noDutSignalBits-1:0] test_data_curr; 
  always @(posedge clk) begin
    if (rst) begin
      test_data <= 'b0; 
    end else begin
      if (test_data == {CTR_WIDTH{ 1'b1}}) begin // stop since all inputs are tested
        #5 $display("Testing done, no inputs=%d", test_data+1); 
        $finish; 
      end else begin 
        #5 test_data <= test_data + 1; 
      end 
    end
  end

  // <assign correct data from the counter to the test_data_curr>
  // ex:  assign test_data_curr = test_data[0] ?test_data[(1*noDutSignalBits)+log2NoClocks +: noDutSignalBits]  :
    //test_data[log2NoClocks +: noDutSignalBits];

  // <assign test_data_curr to all the signals>

endmodule
